#* vim:ts=4:
#*---------------------------------------------------------------------------*
#* Project
#*        slurpmedia - Slurp multimedia files from news articles
#*        Copyright (C) 1999  klmcw@earthlink.net <Kevin L. McWhirter>
#*
#*        This program is free software; you can redistribute it and/or modify
#*        it under the terms of the GNU General Public License as published by
#*        the Free Software Foundation; either version 2 of the License, or
#*        (at your option) any later version.
#*
#*        This program is distributed in the hope that it will be useful,
#*        but WITHOUT ANY WARRANTY; without even the implied warranty of
#*        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#*        GNU General Public License for more details.
#*
#*        You should have received a copy of the GNU General Public License
#*        along with this program; if not, write to the Free Software
#*        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#*
#* Module
#*        $Id$
#*
#* Description
#*
#*---------------------------------------------------------------------------*
#* $Log$
#*---------------------------------------------------------------------------*
package smOpts;
use strict;

#*---------------------------------------------------------------------------*
sub new {
	my $class = shift;
	my $self = bless {
		nntp_srvr	=>	''
	,	nntp_user	=>	''
	,	nntp_pass	=>	''
	,	nntp_auth	=>	0
	,	nntp_grp	=>	''

	,	sm_inst_dir	=>	$::theApp->path_fix($ENV{HOME}, ".slurpmedia")
	,	sm_sort_col	=>	$smfmMain::colSubject
	,	sm_verbose	=>	0

#	,	font_title	=>	'-*-Helvetica-Bold-R-Normal-*-*-180-*-*-*-*-*'
#	,	font_link	=>	'-*-Times-*-R-Normal-*-*-60-*-*-*-*-*'
	,	font_title	=>	'Courier'
	,	font_link	=>	'Courier'

	,	no_export	=>	{
			no_export	=>	1
		,	sm_file		=>	1
		}
	,	sm_file		=>	undef
	}, $class;

	$::theApp->path_make($self->{sm_inst_dir});
	$self->{sm_file} = $::theApp->path_fix($self->{sm_inst_dir}, "options");

	$self->write if(not $self->read);
	$self->write;

	$self;
}
#*---------------------------------------------------------------------------*
sub options {
	my $self = shift;

	my @res = grep {
		not exists $self->{no_export}->{$_};
	} sort {
		$smOpts::a cmp $smOpts::b;
	} keys %{ $self };

	wantarray ? @res : \@res;
}
#*---------------------------------------------------------------------------*
sub read {
	my $self = shift;
	my $file = $self->{sm_file};

	open(FD, "<$file") or return 0;
	while(<FD>) {
		if(/^(\w*)\s*:\s*(.*)/) {
			$self->{$1} = $2 if(not exists $self->{no_export}->{$1});
		}
	}
	close(FD);
}
#*---------------------------------------------------------------------------*
sub write {
	my $self = shift;
	my $file = $self->{sm_file};

	open(FD, ">$file") or return 0;

	map {
		printf(FD "%s: %s\n", $_, $self->{$_});
	} $self->options;

	close(FD);

	1;
}
#*---------------------------------------------------------------------------*
1;
