#* vim:ts=4:
#*---------------------------------------------------------------------------*
#* Project
#*        slurpmedia - Slurp multimedia files from news articles
#*        Copyright (C) 1999  klmcw@earthlink.net <Kevin L. McWhirter>
#*
#*        This program is free software; you can redistribute it and/or modify
#*        it under the terms of the GNU General Public License as published by
#*        the Free Software Foundation; either version 2 of the License, or
#*        (at your option) any later version.
#*
#*        This program is distributed in the hope that it will be useful,
#*        but WITHOUT ANY WARRANTY; without even the implied warranty of
#*        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#*        GNU General Public License for more details.
#*
#*        You should have received a copy of the GNU General Public License
#*        along with this program; if not, write to the Free Software
#*        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#*
#* Module
#*        $Id$
#*
#* Description
#*
#*---------------------------------------------------------------------------*
#* $Log$
#*---------------------------------------------------------------------------*
package smfmArticle;

require Tk;

# Use to store reference of window until dismissed.
# This way parent can create a new instance and forget about it!
my %wrefs;

#*---------------------------------------------------------------------------*
sub _withdraw {
	my $self = shift;

	$self->{tl}->withdraw;

	$wrefs{$self} = undef;
}
#*---------------------------------------------------------------------------*
sub new {
	my $class = shift;
	my $parent = shift;
	my $smFetch = shift;
	my $hdr = shift;
	my $self = bless {
		parent	=>	$parent
	,	hdr		=>	$hdr
	,	tl		=>	undef
	,	fr		=>	undef
	,	btDis	=>	undef
	,	roTxt	=>	undef
	}, $class;

	$self->{tl} = $parent->Toplevel;
	$self->{tl}->title($hdr);

	$self->{fr} = $self->{tl}->Frame;
	$self->{fr}->pack(qw/-side bottom -fill x/);

	$self->{btDis} = $self->{fr}->Button(
		-text		=>	'Dismiss'
	,	-command	=>	[$self	=>	'_withdraw']
	)->pack;

	$self->{roTxt} = $self->{tl}->Scrolled('ROText'
	,	qw/-scrollbars oe -height 40 -setgrid 1 -wrap word/
	);
	$self->{roTxt}->pack(qw/-side left -expand 1 -fill both/);
	$self->{tl}->Busy;
	$self->{tl}->update;
	$self->{tl}->focus;

	my @lns = $smFetch->fetch_article_lines($hdr);

	map {
		$self->{tl}->update;
		$self->{roTxt}->insert('end', $_);
	} @lns;

	$self->{tl}->Unbusy;
	$self->{tl}->update;

	# Store reference -- we keep track of our own!
	$wrefs{$self} = $self;

	$self;
}
#*---------------------------------------------------------------------------*
1;
#*---------------------------------------------------------------------------*
